--[[
*
* Core.lua
* 
*
]]--

local Wipemate = LibStub("AceAddon-3.0"):NewAddon("Wipemate", "AceConsole-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("Wipemate")

local AceConfig 	= LibStub("AceConfig-3.0")
local AceConfigReg 	= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")
local AceGUI = LibStub("AceGUI-3.0")

-- Create a container frame
local frame = frame

function Wipemate:CreateRankingWindow()
	local frame = AceGUI:Create("Window")
	frame:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end)
	frame:SetTitle("Wipemate Player Ranking")
	frame:SetLayout("List")
	
	local DateFrame = AceGUI:Create("InlineGroup")
	DateFrame:SetFullHeight(true)
	DateFrame:SetWidth(150)
	frame:AddChild(frame)
end

function Wipemate:CreateGui()
    --local frame = AceGUI:Create("Frame")
	frame = AceGUI:Create("Window")
	frame:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end)
	frame:SetTitle("Wipemate Raid Stats")
	frame:EnableResize(false)
	frame:SetLayout("Flow")
	frame:SetWidth(250)
	
	-- Create Checkbox Enable Auto
	local EnableAuto = AceGUI:Create("CheckBox")
	EnableAuto:SetWidth(170)
	EnableAuto:SetLabel("Enable AutoStat")
	EnableAuto:SetCallback("OnValueChanged", function() print("Click!") end)
	EnableAuto:SetValue(true)
	EnableAuto:SetType("checkbox")
	-- Add to the container
	frame:AddChild(EnableAuto)
	
	-- Create Button Wipe
	local ButtonAddWipe = AceGUI:Create("Button")
	ButtonAddWipe:SetWidth(107)
	ButtonAddWipe:SetText("Wipe")
	ButtonAddWipe:SetCallback("OnClick", function() print("Wipe!") end)
	frame:AddChild(ButtonAddWipe)
	
	-- Create Button Wipe
	local ButtonAddKill = AceGUI:Create("Button")
	ButtonAddKill:SetWidth(107)
	ButtonAddKill:SetText("Kill")
	ButtonAddKill:SetCallback("OnClick", function() print("Kill!") end)
	frame:AddChild(ButtonAddKill)
	
	-- Create  
	local DataFrame = AceGUI:Create("InlineGroup")
	DataFrame:SetFullHeight(true)
	DataFrame:SetFullWidth(true)
	frame:AddChild(DataFrame)

end

function Wipemate:OnInitialize()
	Wipemate:Print(L["Use /wm to show the Wipemate window."])
	Wipemate:RegisterChatCommand("rl", function() ReloadUI() end)
	Wipemate:RegisterChatCommand("wm", "CreateGui")
	Wipemate:SetupOptions()
	-- set DND for Addon Development
	--BNSetDND(true)
	--BNSetCustomMessage("Am Addon entwickeln!")
end

function Wipemate:OnEnable()
    -- Called when the addon is enabled
end

function Wipemate:OnDisable()
    -- Called when the addon is disabled
end

--[[
**************************
** CONFIG PANEL
**************************
]]--
local option

function fullOptions()
	if not options then
		options = {
			type = "group",
			name = "Wipemate",
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["Main Options"],
					desc	= L["MAIN_OPTIONS_DESC"],
					args = {
					
					}
				}
			}
		}
	end
	return options
end

function Wipemate:ShowWM()
end

function Wipemate:SetupOptions()
	AceConfigReg:RegisterOptionsTable("Wipemate", fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("Wipemate", nil, nil, "general")

	if LibStub:GetLibrary("LibAboutPanel", true) then
		self.optionsFrame["About"] = LibStub:GetLibrary("LibAboutPanel").new("Wipemate", "Wipemate")
	else
		self:Print("Lib AboutPanel not loaded.")
	end
end

function Wipemate:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions("Wipemate", displayName, "Wipemate", name)
end
